Index: kernel/generic/src/mm/km.c
===================================================================
--- kernel/generic/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/generic/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,283 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericmm
+ * @{
+ */
+
+/**
+ * @file
+ * @brief Kernel virtual memory setup.
+ */
+
+#include <mm/km.h>
+#include <arch/mm/km.h>
+#include <mm/page.h>
+#include <mm/frame.h>
+#include <mm/asid.h>
+#include <config.h>
+#include <typedefs.h>
+#include <lib/ra.h>
+#include <debug.h>
+#include <arch.h>
+#include <align.h>
+#include <macros.h>
+#include <bitops.h>
+
+static ra_arena_t *km_ni_arena;
+
+#define DEFERRED_PAGES_MAX	(PAGE_SIZE / sizeof(uintptr_t)) 
+
+/** Number of freed pages in the deferred buffer. */
+static volatile unsigned deferred_pages;
+/** Buffer of deferred freed pages. */
+static uintptr_t deferred_page[DEFERRED_PAGES_MAX];
+
+/** Flush the buffer of deferred freed pages.
+ *
+ * @return		Number of freed pages.
+ */
+static unsigned km_flush_deferred(void)
+{
+	unsigned i = 0;
+	ipl_t ipl;
+
+	ipl = tlb_shootdown_start(TLB_INVL_ASID, ASID_KERNEL, 0, 0);
+
+	for (i = 0; i < deferred_pages; i++) {
+		page_mapping_remove(AS_KERNEL, deferred_page[i]);
+		km_page_free(deferred_page[i], PAGE_SIZE);
+	}
+
+	tlb_invalidate_asid(ASID_KERNEL);
+
+	as_invalidate_translation_cache(AS_KERNEL, 0, -1);
+	tlb_shootdown_finalize(ipl);
+
+	return i;
+}
+
+/** Architecture dependent setup of identity-mapped kernel memory. */
+void km_identity_init(void)
+{
+	km_identity_arch_init();
+	config.identity_configured = true;
+}
+
+/** Architecture dependent setup of non-identity-mapped kernel memory. */
+void km_non_identity_init(void)
+{
+	km_ni_arena = ra_arena_create();
+	ASSERT(km_ni_arena != NULL);
+	km_non_identity_arch_init();
+	config.non_identity_configured = true;
+}
+
+bool km_is_non_identity(uintptr_t addr)
+{
+	return km_is_non_identity_arch(addr);
+}
+
+void km_non_identity_span_add(uintptr_t base, size_t size)
+{
+	bool span_added;
+
+	page_mapping_make_global(base, size);
+
+	span_added = ra_span_add(km_ni_arena, base, size);
+	ASSERT(span_added);
+}
+
+uintptr_t km_page_alloc(size_t size, size_t align)
+{
+	return ra_alloc(km_ni_arena, size, align);
+}
+
+void km_page_free(uintptr_t page, size_t size)
+{
+	ra_free(km_ni_arena, page, size);
+}
+
+static uintptr_t
+km_map_aligned(uintptr_t paddr, size_t size, unsigned int flags)
+{
+	uintptr_t vaddr;
+	size_t align;
+	uintptr_t offs;
+
+	ASSERT(ALIGN_DOWN(paddr, FRAME_SIZE) == paddr);
+	ASSERT(ALIGN_UP(size, FRAME_SIZE) == size);
+
+	align = ispwr2(size) ? size : (1U << (fnzb(size) + 1));
+	vaddr = km_page_alloc(size, max(PAGE_SIZE, align));
+
+	page_table_lock(AS_KERNEL, true);
+	for (offs = 0; offs < size; offs += PAGE_SIZE) {
+		page_mapping_insert(AS_KERNEL, vaddr + offs, paddr + offs,
+		    flags);
+	}
+	page_table_unlock(AS_KERNEL, true);
+	
+	return vaddr;
+}
+
+static void km_unmap_aligned(uintptr_t vaddr, size_t size)
+{
+	uintptr_t offs;
+	ipl_t ipl;
+
+	ASSERT(ALIGN_DOWN(vaddr, PAGE_SIZE) == vaddr);
+	ASSERT(ALIGN_UP(size, PAGE_SIZE) == size);
+
+	page_table_lock(AS_KERNEL, true);
+
+	ipl = tlb_shootdown_start(TLB_INVL_ASID, ASID_KERNEL, 0, 0);
+
+	for (offs = 0; offs < size; offs += PAGE_SIZE)
+		page_mapping_remove(AS_KERNEL, vaddr + offs);
+
+	tlb_invalidate_asid(ASID_KERNEL);
+
+	as_invalidate_translation_cache(AS_KERNEL, 0, -1);
+	tlb_shootdown_finalize(ipl);
+	page_table_unlock(AS_KERNEL, true);
+
+	km_page_free(vaddr, size);
+}
+
+/** Map a piece of physical address space into the virtual address space.
+ *
+ * @param paddr		Physical address to be mapped. May be unaligned.
+ * @param size		Size of area starting at paddr to be mapped.
+ * @param flags		Protection flags to be used for the mapping.
+ *
+ * @return New virtual address mapped to paddr.
+ */
+uintptr_t km_map(uintptr_t paddr, size_t size, unsigned int flags)
+{
+	uintptr_t page;
+	size_t offs; 
+
+	offs = paddr - ALIGN_DOWN(paddr, FRAME_SIZE); 
+	page = km_map_aligned(ALIGN_DOWN(paddr, FRAME_SIZE),
+	    ALIGN_UP(size + offs, FRAME_SIZE), flags);
+
+	return page + offs;
+}
+
+/** Unmap a piece of virtual address space.
+ *
+ * @param vaddr		Virtual address to be unmapped. May be unaligned, but
+ *			it must a value previously returned by km_map().
+ * @param size		Size of area starting at vaddr to be unmapped.
+ */
+void km_unmap(uintptr_t vaddr, size_t size)
+{
+	size_t offs; 
+
+	offs = vaddr - ALIGN_DOWN(vaddr, PAGE_SIZE); 
+	km_unmap_aligned(ALIGN_DOWN(vaddr, PAGE_SIZE),
+	    ALIGN_UP(size + offs, PAGE_SIZE));
+}
+
+/** Unmap kernel non-identity page.
+ *
+ * @param[in] page	Non-identity page to be unmapped.
+ */
+static void km_unmap_deferred(uintptr_t page)
+{
+	page_table_lock(AS_KERNEL, true);
+
+	if (deferred_pages == DEFERRED_PAGES_MAX) {
+		(void) km_flush_deferred();
+		deferred_pages = 0;
+	}
+
+	deferred_page[deferred_pages++] = page;
+
+	page_table_unlock(AS_KERNEL, true);
+}
+
+/** Create a temporary page.
+ *
+ * The page is mapped read/write to a newly allocated frame of physical memory.
+ * The page must be returned back to the system by a call to
+ * km_temporary_page_put().
+ *
+ * @param[inout] framep	Pointer to a variable which will receive the physical
+ *			address of the allocated frame.
+ * @param[in] flags	Frame allocation flags. FRAME_NONE or FRAME_NO_RESERVE.
+ * @return		Virtual address of the allocated frame.
+ */
+uintptr_t km_temporary_page_get(uintptr_t *framep, frame_flags_t flags)
+{
+	uintptr_t frame;
+	uintptr_t page;
+
+	ASSERT(THREAD);
+	ASSERT(framep);
+	ASSERT(!(flags & ~FRAME_NO_RESERVE));
+
+	/*
+	 * Allocate a frame, preferably from high memory.
+	 */
+	frame = (uintptr_t) frame_alloc(ONE_FRAME,
+	    FRAME_HIGHMEM | FRAME_ATOMIC | flags); 
+	if (frame) {
+		page = km_map(frame, PAGE_SIZE,
+		    PAGE_READ | PAGE_WRITE | PAGE_CACHEABLE);
+		ASSERT(page);	// FIXME
+	} else {
+		frame = (uintptr_t) frame_alloc_noreserve(ONE_FRAME,
+		    FRAME_LOWMEM);
+		page = PA2KA(frame);
+	}
+
+	*framep = frame;
+	return page;	
+}
+
+/** Destroy a temporary page.
+ *
+ * This function destroys a temporary page previously created by
+ * km_temporary_page_get(). The page destruction may be immediate or deferred.
+ * The frame mapped by the destroyed page is not freed.
+ *
+ * @param[in] page	Temporary page to be destroyed.
+ */
+void km_temporary_page_put(uintptr_t page)
+{
+	ASSERT(THREAD);
+
+	if (km_is_non_identity(page))
+		km_unmap_deferred(page);
+}
+
+/** @}
+ */
+
Index: kernel/generic/src/mm/page.c
===================================================================
--- kernel/generic/src/mm/page.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/mm/page.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -53,5 +53,5 @@
  * We assume that the other processors are either not using the mapping yet
  * (i.e. during the bootstrap) or are executing the TLB shootdown code.  While
- * we don't care much about the former case, the processors in the latter case 
+ * we don't care much about the former case, the processors in the latter case
  * will do an implicit serialization by virtue of running the TLB shootdown
  * interrupt handler.
@@ -74,4 +74,5 @@
 #include <syscall/copy.h>
 #include <errno.h>
+#include <align.h>
 
 /** Virtual operations for page subsystem. */
@@ -81,28 +82,4 @@
 {
 	page_arch_init();
-}
-
-/** Map memory structure
- *
- * Identity-map memory structure
- * considering possible crossings
- * of page boundaries.
- *
- * @param addr Address of the structure.
- * @param size Size of the structure.
- *
- */
-void map_structure(uintptr_t addr, size_t size)
-{
-	size_t length = size + (addr - (addr & ~(PAGE_SIZE - 1)));
-	size_t cnt = length / PAGE_SIZE + (length % PAGE_SIZE > 0);
-	
-	size_t i;
-	for (i = 0; i < cnt; i++)
-		page_mapping_insert(AS_KERNEL, addr + i * PAGE_SIZE,
-		    addr + i * PAGE_SIZE, PAGE_NOT_CACHEABLE | PAGE_WRITE);
-	
-	/* Repel prefetched accesses to the old mapping. */
-	memory_barrier();
 }
 
@@ -176,33 +153,50 @@
 }
 
+/** Make the mapping shared by all page tables (not address spaces).
+ * 
+ * @param base Starting virtual address of the range that is made global.
+ * @param size Size of the address range that is made global.
+ */
+void page_mapping_make_global(uintptr_t base, size_t size)
+{
+	ASSERT(page_mapping_operations);
+	ASSERT(page_mapping_operations->mapping_make_global);
+	
+	return page_mapping_operations->mapping_make_global(base, size);
+}
+
+int page_find_mapping(uintptr_t virt, void **phys)
+{
+	mutex_lock(&AS->lock);
+	
+	pte_t *pte = page_mapping_find(AS, virt, false);
+	if ((!PTE_VALID(pte)) || (!PTE_PRESENT(pte))) {
+		mutex_unlock(&AS->lock);
+		return ENOENT;
+	}
+	
+	*phys = (void *) PTE_GET_FRAME(pte) +
+	    (virt - ALIGN_DOWN(virt, PAGE_SIZE));
+	
+	mutex_unlock(&AS->lock);
+	
+	return EOK;
+}
+
 /** Syscall wrapper for getting mapping of a virtual page.
- * 
- * @retval EOK Everything went find, @p uspace_frame and @p uspace_node
- *             contains correct values.
- * @retval ENOENT Virtual address has no mapping.
- */
-sysarg_t sys_page_find_mapping(uintptr_t virt_address,
-    uintptr_t *uspace_frame)
-{
-	mutex_lock(&AS->lock);
-	
-	pte_t *pte = page_mapping_find(AS, virt_address, false);
-	if (!PTE_VALID(pte) || !PTE_PRESENT(pte)) {
-		mutex_unlock(&AS->lock);
-		
-		return (sysarg_t) ENOENT;
-	}
-	
-	uintptr_t phys_address = PTE_GET_FRAME(pte);
-	
-	mutex_unlock(&AS->lock);
-	
-	int rc = copy_to_uspace(uspace_frame,
-	    &phys_address, sizeof(phys_address));
-	if (rc != EOK) {
-		return (sysarg_t) rc;
-	}
-	
-	return EOK;
+ *
+ * @return EOK on success.
+ * @return ENOENT if no virtual address mapping found.
+ *
+ */
+sysarg_t sys_page_find_mapping(uintptr_t virt, void *phys_ptr)
+{
+	void *phys;
+	int rc = page_find_mapping(virt, &phys);
+	if (rc != EOK)
+		return rc;
+	
+	rc = copy_to_uspace(phys_ptr, &phys, sizeof(phys));
+	return (sysarg_t) rc;
 }
 
Index: kernel/generic/src/mm/reserve.c
===================================================================
--- kernel/generic/src/mm/reserve.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/mm/reserve.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -42,4 +42,7 @@
 #include <typedefs.h>
 #include <arch/types.h>
+#include <debug.h>
+
+static bool reserve_initialized = false;
 
 IRQ_SPINLOCK_STATIC_INITIALIZE_NAME(reserve_lock, "reserve_lock");
@@ -54,4 +57,5 @@
 {
 	reserve = frame_total_free_get();
+	reserve_initialized = true;
 }
 
@@ -67,4 +71,6 @@
 {
 	bool reserved = false;
+
+	ASSERT(reserve_initialized);
 
 	irq_spinlock_lock(&reserve_lock, true);
@@ -111,4 +117,7 @@
 void reserve_force_alloc(size_t size)
 {
+	if (!reserve_initialized)
+		return;
+
 	irq_spinlock_lock(&reserve_lock, true);
 	reserve -= size;
@@ -122,4 +131,7 @@
 void reserve_free(size_t size)
 {
+	if (!reserve_initialized)
+		return;
+
 	irq_spinlock_lock(&reserve_lock, true);
 	reserve += size;
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/proc/program.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -87,8 +87,8 @@
 	 * Create the stack address space area.
 	 */
+	uintptr_t virt = USTACK_ADDRESS;
 	as_area_t *area = as_area_create(as,
 	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE,
-	    STACK_SIZE, USTACK_ADDRESS, AS_AREA_ATTR_NONE,
-	    &anon_backend, NULL);
+	    STACK_SIZE, AS_AREA_ATTR_NONE, &anon_backend, NULL, &virt, 0);
 	if (!area)
 		return ENOMEM;
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/proc/thread.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -173,4 +173,23 @@
 #endif /* CONFIG_FPU */
 	
+	/*
+	 * Allocate the kernel stack from the low-memory to prevent an infinite
+	 * nesting of TLB-misses when accessing the stack from the part of the
+	 * TLB-miss handler written in C.
+	 *
+	 * Note that low-memory is safe to be used for the stack as it will be
+	 * covered by the kernel identity mapping, which guarantees not to
+	 * nest TLB-misses infinitely (either via some hardware mechanism or
+	 * by the construciton of the assembly-language part of the TLB-miss
+	 * handler).
+	 *
+	 * This restriction can be lifted once each architecture provides
+	 * a similar guarantee, for example by locking the kernel stack
+	 * in the TLB whenever it is allocated from the high-memory and the
+	 * thread is being scheduled to run.
+	 */
+	kmflags |= FRAME_LOWMEM;
+	kmflags &= ~FRAME_HIGHMEM;
+
 	thread->kstack = (uint8_t *) frame_alloc(STACK_FRAMES, FRAME_KA | kmflags);
 	if (!thread->kstack) {
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/syscall/syscall.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -146,5 +146,4 @@
 	(syshandler_t) sys_as_area_change_flags,
 	(syshandler_t) sys_as_area_destroy,
-	(syshandler_t) sys_as_get_unmapped_area,
 	
 	/* Page mapping related syscalls. */
@@ -176,7 +175,11 @@
 	(syshandler_t) sys_device_assign_devno,
 	(syshandler_t) sys_physmem_map,
+	(syshandler_t) sys_physmem_unmap,
+	(syshandler_t) sys_dmamem_map,
+	(syshandler_t) sys_dmamem_unmap,
 	(syshandler_t) sys_iospace_enable,
-	(syshandler_t) sys_register_irq,
-	(syshandler_t) sys_unregister_irq,
+	(syshandler_t) sys_iospace_disable,
+	(syshandler_t) sys_irq_register,
+	(syshandler_t) sys_irq_unregister,
 	
 	/* Sysinfo syscalls. */
Index: kernel/test/mm/mapping1.c
===================================================================
--- kernel/test/mm/mapping1.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/test/mm/mapping1.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -31,76 +31,65 @@
 #include <mm/page.h>
 #include <mm/frame.h>
-#include <mm/as.h>
 #include <arch/mm/page.h>
+#include <mm/km.h>
 #include <typedefs.h>
 #include <debug.h>
 #include <arch.h>
 
-#define PAGE0  0x10000000
-#define PAGE1  (PAGE0 + PAGE_SIZE)
-
-#define VALUE0  UINT32_C(0x01234567)
-#define VALUE1  UINT32_C(0x89abcdef)
+#define TEST_MAGIC  UINT32_C(0x01234567)
 
 const char *test_mapping1(void)
 {
-	uintptr_t frame0, frame1;
-	uint32_t v0, v1;
+	uintptr_t page0, page1;
+	uintptr_t frame;
+	uint32_t v;
+	int i;
 	
-	frame0 = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_KA);
-	frame1 = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_KA);
+	frame = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_NONE);
+
+	page0 = km_map(frame, FRAME_SIZE,
+	    PAGE_READ | PAGE_WRITE | PAGE_CACHEABLE);
+	TPRINTF("Virtual address %p mapped to physical address %p.\n",
+	    (void *) page0, (void *) frame);
+	page1 = km_map(frame, FRAME_SIZE,
+	    PAGE_READ | PAGE_WRITE | PAGE_CACHEABLE);
+	TPRINTF("Virtual address %p mapped to physical address %p.\n",
+	    (void *) page1, (void *) frame);
 	
-	TPRINTF("Writing %#" PRIx32 " to physical address %p.\n",
-	    (uint32_t) VALUE0, (void *) KA2PA(frame0));
-	*((uint32_t *) frame0) = VALUE0;
+	for (i = 0; i < 2; i++) {
+		TPRINTF("Writing magic using the first virtual address.\n");
+
+		*((uint32_t *) page0) = TEST_MAGIC;
+
+		TPRINTF("Reading magic using the second virtual address.\n");
+
+		v = *((uint32_t *) page1);
 	
-	TPRINTF("Writing %#" PRIx32 " to physical address %p.\n",
-	    (uint32_t) VALUE1, (void *) KA2PA(frame1));
-	*((uint32_t *) frame1) = VALUE1;
+		if (v != TEST_MAGIC) {
+			km_unmap(page0, PAGE_SIZE);
+			km_unmap(page1, PAGE_SIZE);
+			frame_free(frame);
+			return "Criss-cross read does not match the value written.";
+		}
+
+		TPRINTF("Writing zero using the second virtual address.\n");
 	
-	page_table_lock(AS, true);
+		*((uint32_t *) page1) = 0;
 
-	TPRINTF("Mapping virtual address %p to physical address %p.\n",
-	    (void *) PAGE0, (void *) KA2PA(frame0));
-	page_mapping_insert(AS_KERNEL, PAGE0, KA2PA(frame0), PAGE_PRESENT | PAGE_WRITE);
+		TPRINTF("Reading zero using the first virtual address.\n");
 	
-	TPRINTF("Mapping virtual address %p to physical address %p.\n",
-	    (void *) PAGE1, (void *) KA2PA(frame1));
-	page_mapping_insert(AS_KERNEL, PAGE1, KA2PA(frame1), PAGE_PRESENT | PAGE_WRITE);
+		v = *((uint32_t *) page0);
+	
+		if (v != 0) {
+			km_unmap(page0, PAGE_SIZE);
+			km_unmap(page1, PAGE_SIZE);
+			frame_free(frame);
+			return "Criss-cross read does not match the value written.";
+		}
+	}
 
-	page_table_unlock(AS, true);
-	
-	v0 = *((uint32_t *) PAGE0);
-	v1 = *((uint32_t *) PAGE1);
-	TPRINTF("Value at virtual address %p is %#" PRIx32 ".\n",
-	    (void *) PAGE0, v0);
-	TPRINTF("Value at virtual address %p is %#" PRIx32 ".\n",
-	    (void *) PAGE1, v1);
-	
-	if (v0 != VALUE0)
-		return "Value at v0 not equal to VALUE0";
-	if (v1 != VALUE1)
-		return "Value at v1 not equal to VALUE1";
-	
-	TPRINTF("Writing %#" PRIx32 " to virtual address %p.\n",
-	    (uint32_t) 0, (void *) PAGE0);
-	*((uint32_t *) PAGE0) = 0;
-	
-	TPRINTF("Writing %#" PRIx32 " to virtual address %p.\n",
-	    (uint32_t) 0, (void *) PAGE1);
-	*((uint32_t *) PAGE1) = 0;
-	
-	v0 = *((uint32_t *) PAGE0);
-	v1 = *((uint32_t *) PAGE1);
-	
-	TPRINTF("Value at virtual address %p is %#" PRIx32 ".\n",
-	    (void *) PAGE0, *((uint32_t *) PAGE0));
-	TPRINTF("Value at virtual address %p is %#" PRIx32 ".\n",
-	    (void *) PAGE1, *((uint32_t *) PAGE1));
-	
-	if (v0 != 0)
-		return "Value at v0 not equal to 0";
-	if (v1 != 0)
-		return "Value at v1 not equal to 0";
+	km_unmap(page0, PAGE_SIZE);
+	km_unmap(page1, PAGE_SIZE);
+	frame_free(frame);
 	
 	return NULL;
Index: kernel/test/mm/mapping1.def
===================================================================
--- kernel/test/mm/mapping1.def	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/test/mm/mapping1.def	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -3,4 +3,4 @@
 	"Mapping test",
 	&test_mapping1,
-	false
+	true	
 },
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ tools/autotool.py	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -184,4 +184,37 @@
 	sys.stderr.write("ok\n")
 
+def check_app_alternatives(alts, args, name, details):
+	"Check whether an application can be executed (use several alternatives)"
+	
+	tried = []
+	found = None
+	
+	for alt in alts:
+		working = True
+		cmdline = [alt] + args
+		tried.append(" ".join(cmdline))
+		
+		try:
+			sys.stderr.write("Checking for %s ... " % alt)
+			subprocess.Popen(cmdline, stdout = subprocess.PIPE, stderr = subprocess.PIPE).wait()
+		except:
+			sys.stderr.write("failed\n")
+			working = False
+		
+		if (working):
+			sys.stderr.write("ok\n")
+			found = alt
+			break
+	
+	if (found is None):
+		print_error(["%s is missing." % name,
+		             "",
+		             "Please make sure that it is installed in your",
+		             "system (%s)." % details,
+		             "",
+		             "The following alternatives were tried:"] + tried)
+	
+	return found
+
 def check_gcc(path, prefix, common, details):
 	"Check for GCC"
@@ -459,5 +492,8 @@
 	
 	for key, value in common.items():
-		outmk.write('%s = %s\n' % (key, value))
+		if (type(value) is list):
+			outmk.write('%s = %s\n' % (key, " ".join(value)))
+		else:
+			outmk.write('%s = %s\n' % (key, value))
 	
 	outmk.close()
@@ -624,5 +660,5 @@
 		# Platform-specific utilities
 		if ((config['BARCH'] == "amd64") or (config['BARCH'] == "ia32") or (config['BARCH'] == "ppc32") or (config['BARCH'] == "sparc64")):
-			check_app(["mkisofs", "--version"], "ISO 9660 creation utility", "usually part of genisoimage")
+			common['GENISOIMAGE'] = check_app_alternatives(["mkisofs", "genisoimage"], ["--version"], "ISO 9660 creation utility", "usually part of genisoimage")
 		
 		probe = probe_compiler(common,
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -64,4 +64,5 @@
 	app/nettest1 \
 	app/nettest2 \
+	app/nettest3 \
 	app/ping \
 	app/websrv \
@@ -92,5 +93,5 @@
 	srv/hid/fb \
 	srv/hid/input \
-	srv/hw/char/i8042 \
+	srv/hid/remcons \
 	srv/hw/char/s3c24xx_uart \
 	srv/net/il/arp \
@@ -104,4 +105,7 @@
 	drv/infrastructure/root \
 	drv/infrastructure/rootvirt \
+	drv/char/i8042 \
+	drv/char/ps2mouse \
+	drv/char/xtkbd \
 	drv/test/test1 \
 	drv/test/test2 \
@@ -118,5 +122,7 @@
 	drv/bus/usb/vhc \
 	drv/nic/lo \
-	drv/nic/ne2k
+	drv/nic/ne2k \
+	drv/nic/e1k \
+	drv/nic/rtl8139
 
 ifeq ($(CONFIG_PCC),y)
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/app/init/init.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -302,5 +302,4 @@
 	spawn("/srv/obio");
 	srv_start("/srv/cuda_adb");
-	srv_start("/srv/i8042");
 	srv_start("/srv/s3c24ser");
 	srv_start("/srv/s3c24ts");
@@ -313,4 +312,5 @@
 	
 	spawn("/srv/clip");
+	spawn("/srv/remcons");
 	
 	/*
Index: uspace/app/klog/klog.c
===================================================================
--- uspace/app/klog/klog.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/app/klog/klog.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -205,13 +205,6 @@
 	klog_length = size / sizeof(wchar_t);
 	
-	klog = (wchar_t *) as_get_mappable_page(size);
-	if (klog == NULL) {
-		fprintf(stderr, "%s: Unable to allocate virtual memory area\n",
-		    NAME);
-		return ENOMEM;
-	}
-	
-	rc = physmem_map((void *) faddr, (void *) klog, pages,
-	    AS_AREA_READ | AS_AREA_CACHEABLE);
+	rc = physmem_map((void *) faddr, pages,
+	    AS_AREA_READ | AS_AREA_CACHEABLE, (void *) &klog);
 	if (rc != EOK) {
 		fprintf(stderr, "%s: Unable to map klog\n", NAME);
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/app/mkbd/main.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -48,4 +48,5 @@
 #include <usb/dev/pipes.h>
 #include <async.h>
+#include <usb/dev.h>
 #include <usb/hid/usages/core.h>
 #include <usb/hid/hidparser.h>
Index: uspace/app/netecho/netecho.c
===================================================================
--- uspace/app/netecho/netecho.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/app/netecho/netecho.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -241,4 +241,6 @@
 		/* Accept a socket if a stream socket is used */
 		addrlen = sizeof(address_buf);
+		if (verbose)
+			printf("accept()\n");
             	socket_id = accept(listening_id, (void *) address_buf, &addrlen);
 		if (socket_id <= 0) {
@@ -258,4 +260,6 @@
 
 		/* Receive a message to echo */
+		if (verbose)
+			printf("recvfrom()\n");
 		rcv_size = recvfrom(socket_id, data, size, 0, address,
 		    &addrlen);
@@ -297,7 +301,17 @@
 
 			/* Answer the request either with the static reply or the original data */
-			rc = sendto(socket_id, reply ? reply : data, reply ? reply_length : length, 0, address, addrlen);
-			if (rc != EOK)
-				socket_print_error(stderr, rc, "Socket send: ", "\n");
+			if (type == SOCK_STREAM) {
+				if (verbose)
+					printf("send()\n");
+				rc = send(socket_id, reply ? reply : data, reply ? reply_length : length, 0);
+				if (rc != EOK)
+					socket_print_error(stderr, rc, "Socket send: ", "\n");
+			} else {
+				if (verbose)
+					printf("sendto()\n");
+				rc = sendto(socket_id, reply ? reply : data, reply ? reply_length : length, 0, address, addrlen);
+				if (rc != EOK)
+					socket_print_error(stderr, rc, "Socket send: ", "\n");
+			}
 		}
 
Index: uspace/app/nettest3/Makefile
===================================================================
--- uspace/app/nettest3/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/app/nettest3/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2011 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+LIBS =
+EXTRA_CFLAGS =
+BINARY = nettest3
+
+SOURCES = \
+	nettest3.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/nettest3/nettest3.c
===================================================================
--- uspace/app/nettest3/nettest3.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/app/nettest3/nettest3.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,128 @@
+/*
+ * Copyright (c) 2011 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nettest
+ * @{
+ */
+
+/** @file
+ * Networking test 3.
+ */
+
+#include <async.h>
+#include <stdio.h>
+#include <str.h>
+
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+#include <net/socket.h>
+
+#define BUF_SIZE 32
+
+static char *data;
+static size_t size;
+
+static char buf[BUF_SIZE];
+
+static struct sockaddr_in addr;
+
+static uint16_t port;
+
+int main(int argc, char *argv[])
+{
+	int rc;
+	int fd;
+	char *endptr;
+
+	port = 7;
+
+	data = (char *)"Hello World!";
+	size = str_size(data);
+
+	/* Connect to local IP address by default */
+	addr.sin_family = AF_INET;
+	addr.sin_port = htons(port);
+	addr.sin_addr.s_addr = htonl(0x7f000001);
+
+	if (argc >= 2) {
+		printf("parsing address '%s'\n", argv[1]);
+		rc = inet_pton(AF_INET, argv[1], (uint8_t *)&addr.sin_addr.s_addr);
+		if (rc != EOK) {
+			fprintf(stderr, "Error parsing address\n");
+			return 1;
+		}
+		printf("result: rc=%d, family=%d, addr=%x\n", rc,
+		    addr.sin_family, addr.sin_addr.s_addr);
+	}
+
+	if (argc >= 3) {
+		printf("parsing port '%s'\n", argv[2]);
+		addr.sin_port = htons(strtoul(argv[2], &endptr, 10));
+		if (*endptr != '\0') {
+			fprintf(stderr, "Error parsing port\n");
+			return 1;
+		}
+	}
+
+	printf("socket()\n");
+	fd = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
+	printf(" -> %d\n", fd);
+	if (fd < 0)
+		return 1;
+
+	printf("connect()\n");
+	rc = connect(fd, (struct sockaddr *)&addr, sizeof(addr));
+	printf(" -> %d\n", rc);
+	if (rc != 0)
+		return 1;
+
+	printf("send()\n");
+	rc = send(fd, data, size, 0);
+	printf(" -> %d\n", rc);
+	if (rc < 0)
+		return 1;
+
+	do {
+		printf("recv()\n");
+		rc = recv(fd, buf, BUF_SIZE, 0);
+		printf(" -> %d\n", rc);
+	} while (rc > 0);
+
+	async_usleep(1000*1000);
+
+	printf("closesocket()\n");
+	rc = closesocket(fd);
+	printf(" -> %d\n", rc);
+
+	return 0;
+}
+
+
+/** @}
+ */
Index: uspace/app/tester/mm/common.c
===================================================================
--- uspace/app/tester/mm/common.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/app/tester/mm/common.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -342,16 +342,9 @@
 	link_initialize(&area->link);
 	
-	/* Map the memory area */
-	void *addr = as_get_mappable_page(size);
-	if (addr == NULL) {
+	area->addr = as_area_create((void *) -1, size,
+	    AS_AREA_WRITE | AS_AREA_READ);
+	if (area->addr == (void *) -1) {
 		free(area);
 		check_consistency("map_area (a)");
-		return NULL;
-	}
-	
-	area->addr = as_area_create(addr, size, AS_AREA_WRITE | AS_AREA_READ);
-	if (area->addr == (void *) -1) {
-		free(area);
-		check_consistency("map_area (b)");
 		return NULL;
 	}
